---
title: NonDocumentTypeChildNode.nextElementSibling
slug: Web/API/NonDocumentTypeChildNode/nextElementSibling
tags:
  - API
  - DOM
  - NonDocumentTypeChildNode
  - Property
---
<div>{{APIRef("DOM")}}</div>

<p>The <code><strong>NonDocumentTypeChildNode.nextElementSibling</strong></code> read-only property returns the element immediately following the specified one in its parent's children list, or <code>null</code> if the specified element is the last one in the list.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>nextNode</em> = elementNodeReference.nextElementSibling; </pre>

<h2 id="Example">Example</h2>

<pre class="brush: html">&lt;div id="div-01"&gt;Here is div-01&lt;/div&gt;
&lt;div id="div-02"&gt;Here is div-02&lt;/div&gt;

&lt;script type="text/javascript"&gt;
  var el = document.getElementById('div-01').nextElementSibling;
  console.log('Siblings of div-01:');
  while (el) {
    console.log(el.nodeName);
    el = el.nextElementSibling;
  }
&lt;/script&gt;
</pre>

<p>This example outputs the following into the console when it loads:</p>

<pre>Siblings of div-01:
DIV
SCRIPT</pre>

<h2 id="Polyfill_for_Internet_Explorer_8">Polyfill for Internet Explorer 8</h2>

<p>This property is unsupported prior to IE9, so the following snippet can be used to add support to IE8:</p>

<pre class="brush: js">// Source: https://github.com/Alhadis/Snippets/blob/master/js/polyfills/IE8-child-elements.js
if(!("nextElementSibling" in document.documentElement)){
    Object.defineProperty(Element.prototype, "nextElementSibling", {
        get: function(){
            var e = this.nextSibling;
            while(e &amp;&amp; 1 !== e.nodeType)
                e = e.nextSibling;
            return e;
        }
    });
}</pre>

<h2 id="Polyfill_for_Internet_Explorer_9_and_Safari">Polyfill for Internet Explorer 9+ and Safari</h2>

<pre class="brush: js">// Source: https://github.com/jserz/js_piece/blob/master/DOM/NonDocumentTypeChildNode/nextElementSibling/nextElementSibling.md
(function (arr) {
  arr.forEach(function (item) {
    if (item.hasOwnProperty('nextElementSibling')) {
      return;
    }
    Object.defineProperty(item, 'nextElementSibling', {
      configurable: true,
      enumerable: true,
      get: function () {
        var el = this;
        while (el = el.nextSibling) {
          if (el.nodeType === 1) {
              return el;
          }
        }
        return null;
      },
      set: undefined
    });
  });
})([Element.prototype, CharacterData.prototype]);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-nondocumenttypechildnode-nextelementsibling', 'ChildNodenextElementSibling')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Split the <code>ElementTraversal</code> interface in {{domxref("ChildNode")}}, {{domxref("ParentNode")}}, and {{domxref("NonDocumentTypeChildNode")}}. This method is now defined on the former.<br>
    The {{domxref("Element")}} and {{domxref("CharacterData")}} interfaces implemented the new interface.</td>
  </tr>
  <tr>
   <td>{{SpecName('Element Traversal', '#attribute-nextElementSibling', 'ElementTraversal.nextElementSibling')}}</td>
   <td>{{Spec2('Element Traversal')}}</td>
   <td>Added its initial definition to the <code>ElementTraversal</code> pure interface and use it on {{domxref("Element")}}.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.NonDocumentTypeChildNode.nextElementSibling")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("ParentNode.firstElementChild")}}</li>
 <li>{{domxref("ParentNode.lastElementChild")}}</li>
 <li>The {{domxref("ChildNode")}} pure interface.</li>
 <li>Object types implementing this pure interface: {{domxref("CharacterData")}}, {{domxref("Element")}}, and {{domxref("DocumentType")}}.</li>
</ul>
